<?php
require_once 'system/setup.conf';
require_once 'warp/warplib/applet.inc';
require_once 'warp/warplib/appletutils.inc';
require_once 'warp/applets/static/static.inc';
require_once 'warp/conf/currency/default.conf';

class Warp_Currency_Applet extends Warp_Applet
{
var $client;
var $toName, $fromName;
var $toTarget, $fromTarget;
var $currencyList;
var $cfrom, $cto;

    function Warp_Currency_Applet($caption = "Currency Calculator")
    {
       parent::__construct($caption);
		$this->valid = FALSE;
    }

    function getDirectory()
    {
        return "currency";
    }

    function init(&$appMan)
    {
        parent::init($appMan);
        return true;
    }

    function initCurrencyData(&$appMan)
    {
        $fromCurrency = 'GBP';
        $toCurrency = "EUR";

        $this->currencyList = array('GBP', 'EUR', 'USD');

        $this->cfrom = $appMan->queryParameter($this, "cfrom", $fromCurrency);
        $this->cto = $appMan->queryParameter($this, "cto", $toCurrency);
        $this->cfrom = $appMan->queryParameter($this, "chfrom", $this->cfrom);
        $this->cto = $appMan->queryParameter($this, "chto", $this->cto);

        $this->fromName = ($this->cfrom);
        $this->toName = ($this->cto);
    }

    function getRefreshParams(&$appMan)
    {
        return
          $appMan->getArgument($this, "cfrom", $this->cfrom)."&".
          $appMan->getArgument($this, "cto", $this->cto);
    }

    
    function getCurrencyLine(&$appMan, $title, $param, $ignore)
    {
        $cl[] = $title;
        foreach($this->currencyList as $currency) {
           if (strcasecmp($ignore, $currency) == 0) {
              $cl[] = $ignore;
           } else {
              $cl[] = $appMan->getAppletLink($this, $param, $currency, $currency);
           }
        }
        return appletUtils::getGridedContent($cl, count($cl));
    }

    function renderWindow(&$appMan)
    {
        $this->initCurrencyData($appMan);

        $html = $this->renderInfo($appMan);

        $html .= $this->getCurrencyLine($appMan, "<b>From:</b>", "chfrom", $this->fromName);
        $html .= $this->getCurrencyLine($appMan, "<b>To:</b>", "chto", $this->toName);

   	  $html .= $this->getAjaxDiv("conversion.php?f=" . $this->fromName . "&t=" . $this->toName);

        return $html;
    }

    function renderPanel(&$app_man)
    {
        return "";
    }

}

?>

