<?php
require_once 'system/setup.conf';
require_once 'warp/warplib/applet.inc';

class Warp_UserScripts_Applet extends Warp_Applet
{
    function Warp_UserScripts_Applet($caption = "User Scripts")
    {
        parent::__construct($caption);
        $this->muskBinary  = '/usr/local/minerva/bin/musk ';
    }

    function init(&$appMan)
    {
        parent::init($appMan);

        $start = $appMan->queryParameter($this, 'start', 0);
        if ($start) {
           $arg = split('_', $start);
           $cmd = $this->muskBinary . $arg[0] . ' do ' . $arg[1];
           exec($cmd);
        }
    }

    function getDirectory() 
    {
        return "usercode";
    }

    function renderWindow(&$appMan)
    {
        $unsupported = "";
        $html = "";

        $list = array();
        exec($this->muskBinary, $list);

        $v = &$appMan->getView();
        $html .= $v->createTableHeader();
        foreach($list as $entry) {
            $options = array();
            exec($this->muskBinary . "$entry list", $options);

            $linklist = array();
            $linklist[] = "<b>" . ucfirst($entry) . "</b>";
            if (count($options) == 0) {
                $unsupported .= "<p>" . $linklist[0] . " : This has no preparation instructions. Please implement 'list' and 'do' commands to support this script.</p>";
            } else {
                foreach($options as $optlink) {
                    $ref = "${entry}_$optlink";
                    $linklist[] = $this->getAjaxLink("trigger.php?script=$entry&do=$optlink", ucfirst($optlink));
                }
                $html .= $v->createTableRow($linklist);
            }

        }

        $html .= $v->createTableFooter();

        $html .= $unsupported;

        return $html;
    }
}

?>

